using Godot;
using System.Reflection;
using System.Collections.Generic;

namespace Rokojori
{ 
  [Tool]
  [GlobalClass]
  public partial class FloatProperty : ShaderProperty
  { 
    [Export]
    public FloatPropertyName propertyName;

    [Export]
    public float value;

    public override void Apply( Material material )
    {
      propertyName.Set( material, value );
    }

    public void ApplyLerped( Material material, float from, float lerpState )
    {
      var lerpedValue = Mathf.Lerp( from, value, lerpState );
      propertyName.Set( material, lerpedValue );
    }
  }
}